﻿namespace AsyncSample
{
    using System;
    using System.Windows.Input;

    public class DelegateCommand : ICommand
    {
        private Action<object> _execute;
        private Func<object, bool> _canExecute;

        public DelegateCommand(Action<object> execute, Func<object, bool> canExecute)
        {
            this._execute = execute;
            this._canExecute = canExecute;
        }

        public bool CanExecute(object parameter)
        {
            return this._canExecute != null ? _canExecute(parameter) : true;
        }

        public event System.EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            if (this._execute != null)
                this._execute(parameter);
        }

        public void RaiseCanExecuteChanged()
        {
            var h = CanExecuteChanged;
            if (h != null)
                h(this, EventArgs.Empty);
        }
    }
}
