﻿namespace AsyncSample
{
    using System.ComponentModel;
    using System.Runtime.CompilerServices;

    public abstract class NotificationObject : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged = (_, __) => { };

        protected virtual void RaisePropertyChanged([CallerMemberName]string propertyName = null)
        {
            var h = PropertyChanged;
            if (h != null)
                h(this, new PropertyChangedEventArgs(propertyName));
        }

        protected virtual bool SetProperty<T>(ref T target, T value, string propertyName = null)
        {
            target = value;
            RaisePropertyChanged(propertyName);
            return true;
        }
    }
}
